#ifndef cptc_geomsh_utils_h
#define cptc_geomsh_utils_h

/* define memory allocation symbols */

#define cptc_malloc malloc

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <types.h>
#include <xdr.h>
#include "GeoFmt.h"
#include "MshFmt2.h"

extern bool_t xdr_int_vector(XDR *xdrs, int **array, int num_elements);
extern int    generate_Cptc_header(char *header, char *type, char *prefix);
extern bool_t xdr_Cptc_header(XDR *xdrs, char **header_p);
extern bool_t cptc_xdr_write_header(XDR *xdrs, char *type, char *prefix);
extern bool_t cptc_xdr_read_and_ignore_header(XDR *xdrs);
extern void   cptc_free_prop_or_val(int count, char **array);
extern int    cptc_MshElemNumNodes(int type);
extern int    cptc_MshElemNumFaces(int type);
extern int    cptc_MshElemNumEdges(int type);
#ifndef _WIN32
extern char  *cptc_geo_id(Cptc_GeomDesc* geom);
#endif

#ifdef __cplusplus
}
#endif

#endif
