function [varargout]=gm_vizp(varargin)
%% gm_vizp converts a mesh or brep to a list of points and segments or polygons
%%   Tcl/Tk:  gmset {coords simps colors} \
%%               [gm_vizp $obj $defaultcolor $dim $bezsub]
%%       or   gmset {coords simps colors} \
%%               [gm_vizp $mesh $brep $defaultcolor $dim $bezsub]
%%   Matlab: [coords,simps,colors] = gm_vizp(obj, defaultcolor, dim, bezsub);
%%  or  [coords,simps,colors] = gm_vizp(mesh, brep, defaultcolor, dim, bezsub);
%% This routine is a low-level routine used by gmviz.  It takes as input
%% a brep or simplicial complex and returns a matrix of coordinates,
%% simplex indices and colors used for graphics. The argument defaultcolor
%% is the color to use if no color is specified for breps; default color
%% is always used for meshes.  The dim argument is the dimension of
%% faces to plot, and bezsub is the amount of subdividing to do on
%% curves and patches.  In the second form of invocation, the simplicial
%% complex is plotted, but it inherits the color field from the brep.
gm_errmsg('gm_vizp')
