function [varargout]=gmchecknormals(varargin)
%% gmchecknormals checks how much the brep faces deviate from being G^1.
%%   Tcl/Tk: gmset {maxvar facename pointnum} [gmchecknormals $b]
%%   Matlab: [maxvar facename pointnum] = gmchecknormals(b);
%% This function returns three values.  The first is the maximum
%% discontinuity of the normal vector (using the QMG metric) at any
%% control point of any brep face.  If all the brep faces are G^1, this
%% number should be very close to zero.  If this number is nonzero, it
%% gives a lower bound for the curvature setting of the QMG to be valid
%% on the brep.  The second return variable is the name of the face (a
%% string) in which the maximum is achieved.  The third return variable
%% is the index of the control point where the max is achieved.
gm_errmsg('gmchecknormals')
