function [varargout]=gmchecktri(varargin)
%% gmchecktri checks whether a mesh is a valid triangulation for a brep
%%   Matlab: asp = gmchecktri(brep, mesh {, checko {, tol}}
%%   Tcl/Tk set asp [gmchecktri $brep $mesh {$checko {$tol}}]
%% This function checks the output of the mesh generator. It returns the
%% worst aspect ratio among simplicies in the triangulation, or a
%% negative number if there is an error in a mesh.  Because the mesh
%% generator is still experimental, it is recommended that you run this
%% utility after every single run of the mesh generator.  The optional
%% argument checko indicates whether you want to check simplex
%% orientation.  If checko=0, then correct orientation of simplices is
%% not checked.  The default is checko=1, which means simplices should
%% have normal orientation.  If checko=2, then all simplices are expected
%% to have reverse orientation.
gm_errmsg('gmchecktri')
