function [varargout]=gmcoarsetopo(varargin)
%% gmcoarsetopo tries to coarsen (reduce the number of) a brep's topological 
%% entities.
%%   Tcl/Tk: gmset b2 [gmcoarsetopo $b $allowable_g1_deviation]
%%   Matlab: b2 = gmcoarsetopo(b, allowable_g1_deviation);
%% This function takes brep b as an argument.  Suppose the dimension of b
%% is d.  Then it tries to merge together topological entities of b that
%% are dimension d-1.  In the process, it may delete topological entities
%% of dimension d-2 or lower.  It merges entities provided the resulting
%% brep is still G^1 up to the allowable deviation.  (This number is in
%% the same metric used to measure curvature.)  The routine will merge
%% entities only if they have the same values for all properties.  Lower
%% dimensional entities will not be deleted if they have any
%% property-value pairs.  Fewer topological entities will generally result
%% in a coarser mesh.
gm_errmsg('gmcoarsetopo')
