function p = gmpolygon(num_side)
% gmpolygon: generate a regular polygon as a brep.  
% p = gmpolygon(num_side)
% Each side is s separate topological edge.

angs = (0 : (num_side - 1)) * 2 * pi / num_side;
verts = [cos(angs'),sin(angs')];
codes = ones(num_side,1);
codes(1) = 0;

p = gm_cpoly(verts,codes);

% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999
% ------------------------------------------------------------------
