function [engine, filename, filestat, notify, format, ...
   thicken, default_color, beziersub] = gmvizgui_get_state(dim)

global GMVIZGUI_HANDLE
if length(GMVIZGUI_HANDLE) == 0
  error('GMVIZGUI_HANDLE global variable not defined');
end

if dim == 2
  h = get(findobj(GMVIZGUI_HANDLE,'tag','2dGraphicsMatlab'), 'value');
  if h == 1
    engine = 'local';
  else
    engine = 'vrml';
  end
else
  h = get(findobj(GMVIZGUI_HANDLE,'tag','3dGraphicsMatlab'), 'value');
  if h == 1
    engine = 'local';
  else
    engine = 'vrml';
  end
end

filename = get(findobj(GMVIZGUI_HANDLE,'tag','FileNameEdit'), 'string');

if get(findobj(GMVIZGUI_HANDLE,'tag','FileReplace'), 'value') == 1
  filestat = 'replace';
else
  filestat = 'append';
end

notify = get(findobj(GMVIZGUI_HANDLE,'tag','Notify'), 'value');

format = 'vrml';

h = findobj(GMVIZGUI_HANDLE,  'tag', 'PointWidthSlider');
v = get(h,'value');
thick1 = 1000^v;

h = findobj(GMVIZGUI_HANDLE,  'tag', 'LineWidthSlider');
v = get(h,'value');
thick2 = 1000^v;

thicken = [thick1,thick2];



h = findobj(GMVIZGUI_HANDLE,  'tag', 'RedSlider');
red = get(h,'value');
h = findobj(GMVIZGUI_HANDLE,  'tag', 'GreenSlider');
green = get(h,'value');
h = findobj(GMVIZGUI_HANDLE,  'tag', 'BlueSlider');
blue = get(h,'value');
h = findobj(GMVIZGUI_HANDLE,  'tag', 'OpacitySlider');
alpha = get(h,'value');

default_color = [red,green,blue,alpha];

h = findobj(GMVIZGUI_HANDLE,  'tag', 'BezierSubdivSlider');
v = get(h,'value');
beziersub = floor(33 * v + 1);
