%test 10 -- two 30-gons.  In the first, each edge is a separate
% topological entity.
% In the second, the edges are merged into one topological entity.

p = gmpolygon(30);

show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end

m1 = gmmeshgen(p, 'show', show);

if show
  gmviz(m1)
end

p2 = gmcoarsetopo(p, .3);
m2 = gmmeshgen(p2, 'show', show);

if show
  gmviz(m2)
end

% How much does brep 2 deviate from G^1? 

[g1dev,g1devf,g1devn] = gmchecknormals(p2);

if show,
    disp(sprintf('deviation of brep2 from G^1 condition is %d on face %s at node %d', g1dev, g1devf, g1devn))
end

asp  = gmchecktri(p,m1);
asp2  = gmchecktri(p2,m2);

[scrap, numvtx] = size(m1{4});
[scrap, numvtx2] = size(m2{4});

global aspprod
global meshsizesum

if length(aspprod) > 0, ...
    aspprod  = aspprod * asp * asp2;
    meshsizesum = meshsizesum + numvtx + numvtx2;
end



% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------


