% QMG test 5 -- test a branching crack

global QMG_DATA
branchobj = gm_read(fullfile(QMG_DATA, 'branchobj.geo'));
show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end

mesh = gmmeshgen(branchobj, 'show', show);

[branchobj2,mesh2] =  gmdouble(branchobj, {'*'}, mesh);

asp  = gmchecktri(branchobj2, mesh2);
[scrap, numvtx] = size(mesh2{4});

if show
   gmviz(mesh)
end 

global aspprod
global meshsizesum

if length(aspprod) > 0
    aspprod  = aspprod * asp;
    meshsizesum = meshsizesum + numvtx;
end



% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------
