%# QMG test 6 -- test a surface crack in a 3D cube

global QMG_DATA
crackcube = gm_read(fullfile(QMG_DATA, 'crackcube.geo'));
show = 0;
global interactive
if length(interactive) > 0
  show = 1;
end
mesh = gmmeshgen(crackcube, 'curve', '(const 1)', 'show', show);

[crackcube2, mesh2] = gmdouble(crackcube, {'*'}, mesh);

asp  = gmchecktri(crackcube2, mesh2);

[scrap, numvtx] = size(mesh2{4});

global aspprod
global meshsizesum

if length(aspprod) > 0
    aspprod  = aspprod * asp;
    meshsizesum = meshsizesum + numvtx;
end



% ------------------------------------------------------------------
% Copyright (c) 1999 by Cornell University.  All rights reserved
% See the accompanying file 'Copyright' for authorship information,
% the terms of the license governing this software, and disclaimers
% concerning this software.
% ------------------------------------------------------------------
% This file is part of the QMG software.  
% Version 2.0 of QMG, release date September 3, 1999.
% ------------------------------------------------------------------
