// ------------------------------------------------------------------
// qlog.h
//
// This file contains the class for generating the mesh generation log.
// ------------------------------------------------------------------
// Author: Stephen A. Vavasis
// Copyright (c) 1999 by Cornell University.  All rights reserved.
// 
// See the accompanying file 'Copyright' for authorship information,
// the terms of the license governing this software, and disclaimers
// concerning this software.
// ------------------------------------------------------------------
// This file is part of the QMG software.  
// Version 2.0 of QMG, release date September 3, 1999.
// ------------------------------------------------------------------

#ifndef QLOG_H
#define QLOG_H

#include "qmgnamesp.h"

class QMG::MG::Logstream {
private:
  ostream& str_;
  int verb_;
  Logstream(const Logstream& o) : str_(o.str_) { }
  char tmp_[100];

public:
  ostream& str() {return str_;}
  int verbosity() const {return verb_;}
  Logstream(ostream& os, int verb) : str_(os), verb_(verb) { }
  void logdate() {
    time_t tm = time(0);
    str_ << "date = " << ctime(&tm) << "\n";
  }
  void change_verbosity(int new_verb) {verb_ = new_verb;}
};

#endif
