#test 10 -- two 30-gons.  In the first, each edge is a separate
# topological entity.
# In the second, the edges are merged into one topological entity.

set show 0
if {[llength [info globals interactive]]} {
    set show 1
}
set p [gmpolygon 30]
set m1 [gmmeshgen $p show $show]
if {$show} {
    gmviz $m1
}

set p2 [gmcoarsetopo $p .3]
set m2 [gmmeshgen $p2 show $show]
if {$show} {
    gmviz $m2
}

# How much does brep 2 deviate from G^1? 

set g1dev [gmchecknormals $p2]

if {$show} {
    puts "deviation of brep2 from G^1 condition is $g1dev"
}


set asp [gmchecktri $p $m1]

gmset {numvtx numelt} [gmmeshsize $m1]

if {[llength [info globals meshsizesum]]} {
    global meshsizesum
    set meshsizesum [expr $meshsizesum + $numvtx]
    global aspprod
    set aspprod [expr $aspprod * $asp]
}

set asp [gmchecktri $p2 $m2]
gmset {numvtx numelt} [gmmeshsize $m2]

if {[llength [info globals meshsizesum]]} {
    set meshsizesum [expr $meshsizesum + $numvtx]
    set aspprod [expr $aspprod * $asp]
}



# ------------------------------------------------------------------
# Copyright (c) 1999 by Cornell University.  All rights reserved
# See the accompanying file 'Copyright' for authorship information,
# the terms of the license governing this software, and disclaimers
# concerning this software.
# ------------------------------------------------------------------
# This file is part of the QMG software.  
# Version 2.0 of QMG, release date September 3, 1999.
# ------------------------------------------------------------------



