# QMG test 11: miscellaneous tests.

set show 0
if {[llength [info globals interactive]]} {
    set show 1
}


# test gm_addpropval & size control property

# make a square
gmset gradedsquare [gm_cpoly {{0 0} {0 1} {1 1} {1 0}} {0 1 1 1}]
gmset gradedsquare \
	[gm_addpropval $gradedsquare e1 {sizecontrol} {"(formula 1.005-%1)"}]

set pr1 [gm_lookup_prop [gm_obj2list $gradedsquare] 1 0 sizecontrol]
if {$show} {
    puts "prop = $pr1"
}


gmset mesh [gmmeshgen $gradedsquare show $show]

if {$show} {
    gmviz $mesh
}

set asp [gmchecktri $gradedsquare $mesh]

if {[llength [info globals meshsizesum]]} {
    gmset {numvtx numelt} [gmmeshsize $mesh]
    global meshsizesum
    set meshsizesum [expr $meshsizesum + $numvtx]
    global aspprod
    set aspprod [expr $aspprod * $asp]
}

# test gmboundary

gmset m2 [gmboundary $mesh]

if {[llength [info globals meshsizesum]]} {
    gmset {numvtx numelt} [gmmeshsize $m2]
    set meshsizesum [expr $meshsizesum + $numvtx]
}

# test gmq11read

global qmg_data
gmset tubeobj [gmq11read $qmg_data/tubeobj.brp]
gmset m [gmmeshgen $tubeobj show $show]
gmset {numvtx numelt} [gmmeshsize $m]


# test xdr read/write

gmxdr_write $tubeobj tubeobj.xdrgeo
gmset tubeobj2 [gmxdr_read tubeobj.xdrgeo]

gmxdr_write $m tubeobj.xdrmsh
gmset m2 [gmxdr_read tubeobj.xdrmsh]
set asp [gmchecktri $tubeobj2 $m2]

if {[llength [info globals meshsizesum]]} {
    set meshsizesum [expr $meshsizesum + $numvtx]
    set aspprod [expr $aspprod * $asp]
}



# ------------------------------------------------------------------
# Copyright (c) 1999 by Cornell University.  All rights reserved
# See the accompanying file 'Copyright' for authorship information,
# the terms of the license governing this software, and disclaimers
# concerning this software.
# ------------------------------------------------------------------
# This file is part of the QMG software.  
# Version 2.0 of QMG, release date September 3, 1999.
# ------------------------------------------------------------------






