## Test 4: mesh a cylinder with two small spheres removed (like bubbles)


global qmg_data

gmset cyl1 [gmmake_cyl 4]
gmset s [gm_read $qmg_data/sphere3.geo]
gmset bubble1 [gmapply \
	[gmcompose [gmtranslate -.02 0 0] [gmdilate .01 .01 .01]] \
	$s]
gmset bubble2 [gmapply \
	[gmcompose [gmtranslate .02 0 0] [gmdilate .01 .01 .01]] \
	$s]
gmset cyl2 [gmcavity $cyl1 $bubble1]
gmset cyl3 [gmcavity $cyl2 $bubble2]

set show 0
if {[llength [info globals interactive]]} {
    set show 1
}

gmset mesh [gmmeshgen $cyl3 curve "(const 1.2)" show $show]
set asp [gmchecktri $cyl3 $mesh]

if {[llength [info globals aspprod]]} {
    global aspprod
    set aspprod [expr $aspprod * $asp]
    gmset {numvtx numelt} [gmmeshsize $mesh]
    global meshsizesum
    set meshsizesum [expr $meshsizesum + $numvtx]
}

# ------------------------------------------------------------------
# Copyright (c) 1999 by Cornell University.  All rights reserved
# See the accompanying file 'Copyright' for authorship information,
# the terms of the license governing this software, and disclaimers
# concerning this software.
# ------------------------------------------------------------------
# This file is part of the QMG software.  
# Version 2.0 of QMG, release date September 3, 1999.
# ------------------------------------------------------------------

