# QMG test 8: a cube in standard orientation versus
# a tilted cube.

global qmg_data
gmset cube [gmoffread $qmg_data/cube.off]
set show 0
if {[llength [info globals interactive]]} {
    set show 1
}

gmset mesh [gmmeshgen $cube  show $show]

set asp [gmchecktri $cube $mesh]
gmset {numvtx numelt} [gmmeshsize $mesh]

if {[llength [info globals aspprod]]} {
    global aspprod
    set aspprod [expr $aspprod * $asp]
    global meshsizesum
    set meshsizesum [expr $meshsizesum + $numvtx]
}

gmset q {
    {  -0.84910409704140  -0.40704628877252   0.33665345859509 0}
    {   0.23026379507690  -0.85881459325243  -0.45762001605420 0}
    {   0.47539543231325  -0.31104792751790   0.82295101295431 0}
}

gmset tiltcube [gmapply $q $cube]

gmset mesh2 [gmmeshgen $tiltcube  show $show]

## Display the properties of the second mesh

set asp2 [gmchecktri $tiltcube $mesh2]
gmset {numvtx2 numelt2} [gmmeshsize $mesh2]

if {[llength [info globals aspprod]]} {
    global aspprod
    set aspprod [expr $aspprod * $asp2]
    global meshsizesum
    set meshsizesum [expr $meshsizesum + $numvtx2]
}

# ------------------------------------------------------------------
# Copyright (c) 1999 by Cornell University.  All rights reserved
# See the accompanying file 'Copyright' for authorship information,
# the terms of the license governing this software, and disclaimers
# concerning this software.
# ------------------------------------------------------------------
# This file is part of the QMG software.  
# Version 2.0 of QMG, release date September 3, 1999.
# ------------------------------------------------------------------
