# QMG: test of visualization.

if {[llength [info commands .testviz_continue]] > 0} {
    destroy .testviz_continue
}

if {[lsearch -exact [font names] testviz_buttonfont] < 0} {
    font create testviz_buttonfont -family Times -size 30
}


toplevel .testviz_continue
button .testviz_continue.b \
	-text "Continue" \
	-font testviz_buttonfont \
	-background green \
	-command {incr testviz_buttonpresscount}

pack .testviz_continue.b

set testviz_buttonpresscount 0
proc testviz_waitforbuttonpress {} {
    global testviz_buttonpresscount
    puts "Click on green 'Continue' button on your screen to proceed..."
    tkwait variable testviz_buttonpresscount
    puts "  ... proceeding"
}



puts "This file tests graphics capabilities of QMG 2.0 under Tcl."
puts "First, here is a test of 2D graphics."
gmset g [gm_read $qmg_data/logo2.geo]
gmviz $g blue 1
puts "A plot the letter Q outlined in blue should have appeared"
puts "in a new graphics window.  It will appear very distorted"
puts "if the Bezier subdivision option is a small number."
testviz_waitforbuttonpress
if {[llength [info commands .gmvizgui]] > 0} {
    puts "There is already a visualization control panel on your screen."
} else {
    gmvizgui
    puts "The visualization control panel should have just appeared on"
    puts "your screen."
}
puts "In the visualization control panel, increase the number of"
puts "Bezier subdivisions using the slider."
testviz_waitforbuttonpress
gmviz $g red 1
puts "A plot the letter Q outlined in red should have appeared"
puts "in a new graphics window.  With the increased number"
puts "of Bezier subdivisions, it should appear more like a curved object."
testviz_waitforbuttonpress
puts "Please start your browser.  Your browser should have a VRML"
puts "plug-in.  For more information about VRML plug-ins, see"
puts "http://www.web3d.org."
testviz_waitforbuttonpress
puts  "Click the checkbutton to enable puts notification of your browser."
testviz_waitforbuttonpress
gmset b [gmrndcolor [gmoffread $qmg_data/dodec.off]]
gmviz $b
puts "A dodecahedron with each facet a different color should have"
puts "appeared in the VRML window of your browser."
puts "This is the end of the test."

destroy .testviz_continue
font delete testviz_buttonfont
